#include <iostream>
#define N 75000
using namespace std;
int main()
{
    long long n;
    int M;
    int ljudi;
    cin>>ljudi;
    long long A[N];
    long long B[N];
    for(int i=0;i<ljudi;i++){
        cin>>n;
        cin>>M;
        n--;
        M--;
        long long prvi;
        cin>>prvi;
        long long a;
        for(int j=0;j<n;j++){
            cin>>a;
            A[j]=a-prvi;
            if(A[j]<0) A[j]*=-1;
            prvi=a;
        }
        long long prviB;
        cin>>prviB;
        long long b;
        for(int j=0;j<M;j++){
            cin>>b;
            B[j]=b-prviB;
            if(B[j]<0) B[j]*=-1;
            prviB=b;
        }
        long long razlikamin=A[0];
        for(int j=1;j<n;j++){
            razlikamin=min(razlikamin,A[j]);
        }
        if(razlikamin!=1){
            bool radi=true;
            for(int j=0;j<n;j++){
                if(A[j]%razlikamin) radi=false;
            }
            for(int j=0;j<M;j++){
                if(B[j]%razlikamin==0) radi=false;
            }
            if(radi==false) cout<<0<<endl;
            else cout<<1<<endl;
        }
        else cout<<0<<endl;

    }
    return 0;
}